unit clipbrd_csv;

{$mode objfpc}{$H+}

interface

uses
    LCLType, Windows, ShellApi, Classes, SysUtils, Forms, Controls,
    Graphics, Dialogs, StdCtrls, ComCtrls,
    clipbrd;

const
  CSV_FORMAT = {$IFDEF WINDOWS}'CSV'{$ELSE}'text/html'{$ENDIF};

var
  cfCSV: TClipboardFormat = 0;

function CF_CSV: TClipboardFormat;
procedure SetAsCSV(TextData: String);

implementation

function CF_CSV: TClipboardFormat;
begin
  if cfCSV = 0 then
    cfCSV := RegisterClipboardFormat(CSV_FORMAT);
  Result := cfCSV;
end;

procedure SetAsCSV(TextData: String);
var
  Stream: TStream;
begin
  if CF_CSV = 0 then
    exit;

  {$IFDEF WINDOWS}
  Stream := TStringStream.Create(TextData);
  {$ELSE}
  Stream := TStringStream.Create(TextData);
  {$ENDIF}
  try
    Stream.Position := 0;
    Clipboard.AddFormat(CF_CSV, Stream);

  finally
    Stream.Free;
  end;
end;

end.

